import re
import requests
import tldextract
from lxml import etree
from ezpymysql import Connection


def save_to_db(url, html):
    db = Connection(
        'localhost',
        'sinanew',
        'root',
        '123456'
    )
    item = {
        'title': html,
        'url': url,
    }
    last_id = db.table_insert('sinatilte', item)

# 输入为 respond
# 利用了xpath 分析 //a  获取根节点中所有的a标签，最后组装为字典数组
def analysisA(htmlText):
    linklist = htmlText.xpath("//a")
    news_linkDics = []
    for item in linklist:
        if len(item.xpath("@href")) > 0 and len(item.xpath("text()")) > 0:
            ADic = {item.xpath("@href")[0]: item.xpath("text()")[0]}
            news_linkDics.append(ADic)
    return news_linkDics


def crawl():
    sina_url = "https://news.sina.com.cn/"
    # 设置请求头 防封
    _headers = {
        'User-Agent': ('Mozilla/5.0 (compatible; MSIE 9.0; '
                       'Windows NT 6.1; Win64; x64; Trident/5.0)'),
    }
    htmlText = requests.get(sina_url, headers=_headers).text.encode(
        'iso-8859-1').decode('utf-8')
# 提取response 中的a标签 的href 和 文本，
# 得到的结果为 [{"url"：“text"}]
    DicArray = analysisA(etree.HTML(htmlText))

    news_links = []
    # 遍历字典数组中的元素。筛选符合 sina 域名的http
    for idx, item in enumerate(DicArray):
        dicKey = list(item.keys())[0]
        dicValue = item[dicKey]
        if not dicKey.startswith('http'):
            continue
        domain = tldextract.extract(dicKey)
        if domain == "sina":
            continue
        news_links.append(DicArray[idx])
    for link in news_links:
        dicKey = list(link.keys())[0]
        dicValue = link[dicKey]
        save_to_db(dicKey, dicValue)


if __name__ == '__main__':
    crawl()
